/*

Le projet d'Oscillation d'un Fil en angles consiste  simuler les oscillations
d'un pendule de n masses identiques lies entre elles par des tiges rigides, en
utilisant les angles qu'elles font avec la verticale dans un repre euclidien.

Le problme est ici rsolu en utilisant les outils suivants :
_coordonnes angulaires
_quations de Lagrange
_mthode d'Euler

Auteur : Thibault Raffaillac
Cr le : 29/04/07

*/

#ifndef TRAF_MAIN_H
#define TRAF_MAIN_H

//La constante qui influe sur le ralisme de la simulation
#define G_SUR_L 98.1

//Cette macro lve au carr son argument.
#define CARRE(arg) ((arg)*(arg))

int main(int argc, char *argv[]);

/*Cette fonction initialise les paramtres des masses de telle faon que le fil
soit en position initiale  la verticale et immobile.*/
void initMasses(void);

/*Cette fonction calcule les coefficients des n systmes linaires  n inconnues
(les acclrations).*/
void calculCoeffs(long numeroImage);

/*Cette fonction ralise l'approximation des positions des masses puis des
vitesses par la mthode d'Euler,  partir des rsultats de la rsolution du
systme d'quations sur les acclrations.

Elle renvoie -1 si une des vitesses calcule dpasse la limite de tours par
seconde.*/
int approxEuler(void);

#endif
