/*

Le projet d'Oscillation d'un Fil en angles consiste  simuler les oscillations
d'un pendule de n masses identiques lies entre elles par des tiges rigides, en
utilisant les angles qu'elles font avec la verticale dans un repre euclidien.

Le problme est ici rsolu en utilisant les outils suivants :
_coordonnes angulaires
_quations de Lagrange
_mthode d'Euler

Auteur : Thibault Raffaillac <thibaultraffaillac@yahoo.fr>
Cr le : 29/04/07

*/

#ifndef TRAF_MAIN_H
#define TRAF_MAIN_H

//La constante qui influe sur le ralisme de la simulation
#define G_SUR_L 98.1

//Cette macro lve au carr son argument.
#define CARRE(arg) ((arg)*(arg))

int main (int argc, char *argv[]);

/*Cette fonction initialise les paramtres des masses de telle faon que le fil
soit en position initiale  la verticale et immobile.*/
void initMasses (void);

/*Cette fonction calcule les coefficients du systme  rsoudre, et prend en
argument les tableaux des positions et des vitesses.*/
void calculCoeffs (double dtblpos[], double dtblvit[]);

/*Cette fonction ralise l'approximation des vitesses  l'aide de la mthode de
Runge-Kutta  l'ordre 4.

Elle renvoie -1 si un des systmes n'a pas pu tre rsolu, en le signalant dans
stderr, 0 si tout s'est bien pass, et 1 si une des vitesses est trop importante.*/
int approxRK4 (long numeroImage);

#endif
